#include "String.h"
#include <cassert>
#include <cstring>
#include <cstdlib>

namespace ecci
{

String::String(const char *cstr)
	: str(nullptr)
	, len(0)
{
	assert(cstr != nullptr);
	len = strlen(cstr);
	str = (char*) malloc(len + 1);
	assert(str);
	strcpy(str, cstr);
}

String::String(const String& other)
	: str( nullptr )
	, len( other.len )
{
	str = (char*) malloc(len + 1);
	assert(str);
	strcpy( str, other.str );
}

const String& String::operator=(const String& other)
{
	if ( this != &other )
	{
		len = other.len;
		free(str);
		str = (char*) malloc(len + 1);
		assert(str);
		strcpy( str, other.str );
	}
	return *this;
}


String::~String()
{
	free(str);
}

} // namespace ecci
