#ifndef STRING_H
#define STRING_H

#include <cstddef>

namespace ecci
{

class String
{
  private:
	char* str;
	size_t len;

  public:
	// Default constructor (ctor)
	String(const char* cstr = "");
	// Copy constructor
	String(const String& other);
	// Assignment operator
	const String& operator=(const String& other);
	// Destructor (dtor)
	~String();
	/// Get access to the internal c-style string
	inline const char* c_str() const { return str; }
	/// Returns the lenght of this string
	inline size_t getLength() const { return len; }
};

} // namespace ecci

#endif // STRING_H
